#
# Thsi file prepares the dataset for the ML model
#

from copy import deepcopy
import random

def getInd(x,y): # enter the hash function here
	return x%y # this is just an example

def prepareDataset(data, time, C, counters, counterLen, long_term_threshold):
	#prepare dataset for ml model
	preDataset = []
	label = []
	ind = 0
	count = -1
	preCycle = []
	windowLength = C
	while True:
		count += 1
		start_cycle = windowLength * count
		end_cycle = windowLength * (count+1) #sliding window of windowLength cycles
		temp = []
		while time[ind] < end_cycle:
			temp.append(data[ind])
			ind += 1
			if ind >= len(data):
				break
		preDataset.append(temp)
		preCycle.append(start_cycle)
		if ind >= len(data):
			break

	dataset1 = []
	dataset2 = []
	dataset3 = []
	cycle = []
	global_count = []
	i = 0
	count = 0
	violations = 0
	historyCounter = [0] * counters
	globalCounter = [0] * counters 
	absMax=-1
	while i < len(preDataset):
		totalAccess = len(preDataset[i])
		if totalAccess == 0:
			i += 1
			continue
		cycle.append(preCycle[i])
		if preCycle[i] > 64000000*count: #time to reset
			count += 1
			historyCounter = [0] * counters
			globalCounter = [0] * counters
		rowGroups = [0] * counters 
		for k in range(len(preDataset[i])):
			ind1 = getInd(preDataset[i][k], counters)
			rowGroups[ind1] += 1
			if rowGroups[ind1] > counterLen: # counterLen = 2^n for n-bit short term counter
				rowGroups[ind1] = counterLen
			globalCounter[ind1] += 1
		temp1 = []
		temp2 = []
		for j in range(len(rowGroups)):
			temp1.append(rowGroups[j])
			temp2.append(rowGroups[j]/totalAccess)
			if rowGroups[j] > long_term_threshold:
				historyCounter[j] += 1
				if historyCounter[j] > counterLen: # n-bit long term counter
					historyCounter[j] = counterLen
		dataset1.append(temp1.copy())
		dataset2.append(temp2.copy())
		dataset3.append(historyCounter.copy())
		global_count.append(globalCounter.copy())
		i += 1
	return dataset1, dataset2, dataset3, global_count, cycle

def start(fname, C, counterLen, counters, long_term_threshold):
	f=open('Output.txt', 'r') # this is the filtered file obtained from 'readDramAddress.py'
	lines = f.readlines()
	numBanks = 8 * 2 # multiplying by 2 as numRanks = 2
	rowBuffer = [-1]*numBanks
	rows = []
	cycles = []
	for i in range(numBanks):
		t=[]
		rows.append(deepcopy(t))
		cycles.append(deepcopy(t))
	baseCycle = 0
	for i in range(len(lines)):
		temp = lines[i].split()
		bankId = int(temp[1]) + (8*int(temp[2]))
		rowAccessed = int(temp[3])
		cycleAccessed = int(temp[4]) 
		if i==0:
			baseCycle = cycleAccessed
		if rowBuffer[bankId] == rowAccessed: # if same row accessed again in same bank
			continue
		rowBuffer[bankId] = rowAccessed # load rowbuffer with new row
		rows[bankId].append(rowAccessed) # record transaction
		cycles[bankId].append((cycleAccessed - baseCycle)) # Add *1E-9 to convert to seconds

	for bankIndex in range(numBanks-15): # just making the dataset for bank 0
		dataset1, dataset2, dataset3, global_count, cycle = prepareDataset(rows[bankIndex], cycles[bankIndex], C, counters, counterLen, long_term_threshold)
		# at this point the training dataset is ready
		# write them to file as ml model will need every training data (for all applications) at the same time
		text_file = open("ml_data/" + fname + "_bank" + str(bankIndex) + ".txt" , "w")
		for i in range(len(dataset1)):
			sumData = 0
			
			sumData += sum(dataset1[i])
			if sumData == 0: # no need to write blanks
				continue
			text_file.write("%d \n" % cycle[i])
			text_file.write("%s \n" % dataset1[i])
			text_file.write("%s \n" % dataset2[i])
			text_file.write("%s \n" % dataset3[i])
			text_file.write("%s \n" % global_count[i])
			
		text_file.close()
