#
# This file is the ml model
#

from sklearn import linear_model
import random
hcfirst = 5000 # this is actually hcfirst/4
filesToReadTrain1 = []
filesToReadTrain2 = []
# all files to read
filesToReadTest1 = [ 'blackscholes_4core_bank0.txt', 'bodytrack_4core_bank0.txt', 'dedup_4core_bank0.txt', 'canneal_4core_bank0.txt',
					'DFT_4core_bank0.txt',  'DJ_4core_bank0.txt', 'DP_4core_bank0.txt', 'fft_4core_bank0.txt',
					 'fluidanimate_4core_bank0.txt', 'freqmine_4core_bank0.txt', 'GS_4core_bank0.txt', 'HA_4core_bank0.txt', 
					 'JA_4core_bank0.txt', 'lu_4core_bank0.txt', 'MM_4core_bank0.txt', 'ocean_4core_bank0.txt', 
					 'OE_4core_bank0.txt', 'radix_4core_bank0.txt', 'raytrace_4core_bank0.txt', 'SH_4core_bank0.txt', 
					 'streamcluster_4core_bank0.txt', 'swaptions_4core_bank0.txt', 'TR_4core_bank0.txt',  'volrend_4core_bank0.txt', 
					 'water_4core_bank0.txt', 'x264_4core_bank0.txt','bwaves_4core_bank0.txt', 'bzip2_compress_4core_bank0.txt',
				'bzip2_decompress_4core_bank0.txt', 'gcc_4core_bank0.txt', 'hmmer_4core_bank0.txt', 'leslie_4core_bank0.txt',
				'deepsjeng_4core_bank0.txt', 'exchange2_4core_bank0.txt','lbm_4core_bank0.txt','mcf17_4core_bank0.txt',
				'namd_4core_bank0.txt', 'povray17_4core_bank0.txt', 'specrand_4core_bank0.txt', 'multiProg5_4core_bank0.txt'
				'multiProg1_4core_bank0.txt', 'multiProg2_4core_bank0.txt', 'multiProg3_4core_bank0.txt', 'multiProg4_4core_bank0.txt']
filesToReadTest2 = ['ghammer_2sided_bank0.txt', 'ghammer_3sided_bank0.txt', 'ghammer_7sided_bank0.txt', 'ghammer_9sided_bank0.txt', 
					'ghammer_12sided_bank0.txt', 'ghammer_15sided_bank0.txt', 'ghammer_19sided_bank0.txt', 'ghammer_22sided_bank0.txt', 
					'ghammer_25sided_bank0.txt', 'ghammer_29sided_bank0.txt', 'advAllAtOnce_2sided_bank0.txt', 'advBurst2_2sided_bank0.txt', 
					'advBurst3_2sided_bank0.txt', 'advBurst5_2sided_bank0.txt','advBurst10_2sided_bank0.txt', 'advUni_2sided_bank0.txt',
					 'advIrreg_2sided_bank0.txt', 'ghammer_4sided_bank0.txt','ghammer_5sided_bank0.txt', 'ghammer_10sided_bank0.txt',
					 'ghammer_14sided_bank0.txt', 'ghammer_16sided_bank0.txt','advBurst2_2sided_bank0.txt','advBurst3_2sided_bank0.txt', 
				'advBurst5_2sided_bank0.txt','advBurst10_2sided_bank0.txt','advBurst10_10sided_bank0.txt','advUni_2sided_bank0.txt',
				'advBurst2_3sided_bank0.txt', 'advBurst2_5sided_bank0.txt', 'advBurst2_10sided_bank0.txt', 'advBurst3_2sided_bank0.txt', 
				'advBurst2_2sided_bank0.txt', 'advBurst3_2sided_bank0.txt', 'advBurst5_2sided_bank0.txt', 'advBurst10_2sided_bank0.txt',
				'advBurst5_2sided_bank0.txt', 'advBurst10_2sided_bank0.txt', 'advBurst3_3sided_bank0.txt', 'advBurst5_5sided_bank0.txt',
				'advIrreg1_2sided_bank0.txt', 'advIrreg2_2sided_bank0.txt', 'advIrreg3_2sided_bank0.txt', 'advIrreg4_2sided_bank0.txt',
				'advIrreg5_2sided_bank0.txt', 'advIrreg1_3sided_bank0.txt', 'advIrreg2_3sided_bank0.txt', 'advIrreg3_3sided_bank0.txt',
				'advIrreg1_5sided_bank0.txt', 'advIrreg2_5sided_bank0.txt', 'advIrreg3_5sided_bank0.txt',
				'advAllAtOnce_3sided_bank0.txt','advAllAtOnce_5sided_bank0.txt','advAllAtOnce_10sided_bank0.txt']

dataset = []
label = []
r_label = []

def readFile(fname):
	f = open("ml_data/" + fname,'r')
	text = f.readlines()
	d1 = []
	d2 = []
	d3 = []
	d_label = []
	c = []
	i = 0
	while i < len(text):
		cycle = text[i]
		data1 = text[i+1][1:-3].split(',')
		data2 = text[i+2][1:-3].split(',')
		data3 = text[i+3][1:-3].split(',')
		data_label = text[i+4][1:-3].split(',')
		assert(len(data1)==len(data2))
		for j in range(len(data1)):
			data1[j] = float(data1[j]) 
			data2[j] = float(data2[j]) 
			data3[j] = float(data3[j]) 
			data_label[j] = float(data_label[j]) 
		d1.append(data1.copy())
		d2.append(data2.copy())
		d3.append(data3.copy()) 
		d_label.append(data_label.copy())
		c.append(cycle)
		i += 5
	return d1, d2, d3, d_label, c

def prepareDatasetTrain(data1, data2, data3, d_label, numInputs, typeInputs):
	global dataset, label, r_label
	count = 0
	for i in range(int(len(data1)/3),len(data1)):
		for j in range(len(data1[i])):
			if data1[i][j] + data2[i][j] == 0: # no information when everything is zero
				continue
			if typeInputs: # 1= attack, 0 = normal
				if d_label[i][j] < hcfirst:
					continue
				thr = numInputs/(len(data1)*0.67)
				if random.random() < (1-thr): # adding some randomness
					continue
				label.append(1)
				r_label.append(d_label[i][j])
			else:
				if d_label[i][j] > hcfirst:
					continue
				thr = numInputs/(len(data1)*0.67)
				if random.random() < (1-thr): # adding some randomness
					continue
				label.append(0)
				r_label.append(d_label[i][j])
			count += 1
			t = [data1[i][j],data2[i][j],data3[i][j]]
			dataset.append(t.copy())
			if count >= numInputs:
				return
	
def prepareDataset(data1, data2, data3, d_label):
	global dataset, label, r2_label
	for i in range(len(data1)):
		for j in range(len(data1[i])):
			if data1[i][j] + data2[i][j] == 0: # no information when all zeros
				continue
			t = [data1[i][j],data2[i][j],data3[i][j]]
			dataset.append(t.copy())
			if d_label[i][j] > hcfirst: #for scalability, change hcfirst
				label.append(1)
			else:
				label.append(0)
			r2_label.append(d_label[i][j])
	
def start(a,b,c):
	global dataset, label, r2_label, r_label, allRecord
	dataset = []
	label = []
	r_label = []
	r2_label = []
	for f in filesToReadTrain1:
		data1, data2, data3, d_label, cycle = readFile(f)
		prepareDatasetTrain(data1, data2, data3, d_label, 75, 0)
	for f in filesToReadTrain2:
		data1, data2, data3, d_label, cycle = readFile(f)
		prepareDatasetTrain(data1, data2, data3, d_label, 70, 1)
	if not 0.45 < sum(label)/len(label) < 0.65:
		return -1,-1, -1, -1 # class imbalance
		
	reg = linear_model.LinearRegression()	

	for i in range(10):
		reg.fit(dataset,label)

	pred = reg.predict(dataset)
	accuracy = 0
	for i in range(len(dataset)):
		if pred [i] > 0.5:
			pred[i] = 1
		else:
			pred[i] = 0
		if pred[i] == label[i]: # correct prediction
			accuracy += 1
		
	trainAcc = accuracy/len(dataset)
	
	total_test_acc = 0
	total_test_dataset = 0
	min_test_acc = 999
	filesToReadTest = filesToReadTest1 + filesToReadTest2
	accReturn = []
	for f in filesToReadTest:
		dataset = []
		label = []
		false_negatives = 0
		data1, data2, data3, d_label, cycle = readFile(f)
		prepareDataset(data1, data2, data3, d_label)
		pred = reg.predict(dataset)
		accuracy = 0
		for i in range(len(dataset)):
			if pred [i] > 0.5:
				pred[i] = 1
			else:
				pred[i] = 0
			if pred[i] == label[i]: # got it right
				accuracy += 1
			else: #wrong prediction
				if  f[:3] == 'adv' and label[i] == 0:
					accuracy += 1 # here, we're being safe; false positives under attack will prevent bit flips	
		testAcc = round(accuracy/len(dataset),2)
		if testAcc < min_test_acc:
			min_test_acc = testAcc
		total_test_acc += accuracy
		total_test_dataset += len(dataset)
		accReturn.append(testAcc)
	allRecord.append(accReturn)
	totalTestAcc = float(total_test_acc)/total_test_dataset
	
	f = open('accuracy.txt','a')
	f.write("%d, %d, %d, Train: %s, Test: %s, minTestAcc: %s\n" % (a,b,c,str(trainAcc),str(totalTestAcc),str(min_test_acc)))
	f.write("weights: %s, bias: %s\n" % (str(reg.coef_), str(reg.intercept_)))
	return 1, accReturn, reg.coef_, reg.intercept_

def makeTrainData():
	global filesToReadTrain1, filesToReadTrain2
	filesToReadTrain1 = []
	filesToReadTrain2 = []
	count = 0
	record = [0]*(len(filesToReadTest1)+len(filesToReadTest2))
	while count < 4:
		r = random.randrange(len(filesToReadTest1))
		if filesToReadTest1[r] in filesToReadTrain1: #file already exists
			continue
		count += 1
		filesToReadTrain1.append(filesToReadTest1[r])
	count = 0
	while count < 4:
		r = random.randrange(len(filesToReadTest2))
		if filesToReadTest2[r] in filesToReadTrain2: #file already exists
			continue
		count += 1
		filesToReadTrain2.append(filesToReadTest2[r])
	minAcc = 0
	for i in range(10):
		didItWork,acc, weights, bias = start(1,2,3) # these numbers are only meant as identifiers, they dont mean anything
		if didItWork == -1: #failed
			print('class imbalance')
			return -1,-1,-1
		if min(acc) < 0.5: # deemed as failure
			return -1,-1,-1
		for j in range(len(record)):
			record[j] += round(acc[j],2)
	return weights, bias, min(acc)

if __name__ == "__main__":
	global allRecord
	allRecord = []
	w_print = []
	b_print = []
	minAcc = 0
	whichIter = -1
	for i in range(10):
		print(i)
		weights, bias, acc = makeTrainData()
		if acc == -1: #failed venture
			continue
		if acc > minAcc:
			whichIter = i
			minAcc = acc
			w_print = weights.copy()
			b_print = bias.copy()
		#print(weights, '\t', bias)
	print('min acc: ', minAcc)
	print(w_print)
	print(b_print)
	print(allRecord[whichIter])
