#
# This file reads the raw Gem5 output and converts it into a more human readable format
#

def getDramPhyLoc(address): #get this info from config.ini file of Gem5. 
	addr = int(address/64) #changes based on dram type/configurations
	addr = int(addr/128)
	bank = addr % 8
	addr = int(addr/8)
	rank = addr % 2
	addr = int(addr/2)
	row = addr % 4096 
	return bank, rank, row

def start(fname, numAggressors):
	f = open('gem5Data/' + fname + ".txt",'r')
	lines = f.readlines()

	addressAccessed = []
	cyclesAccessed = []
	clk_base = -1

	for i in range(len(lines)):
		t = lines[i].split(',')
		senderID = int(t[0])
		typeOfMsg = t[1]
		address = int(t[2])
		clockCycle = int(t[5][:-1])/1000
		if typeOfMsg != 'u':
			continue
		if address < maxAddress: #this number is max DRAM address from config.ini file
			if clk_base == -1:
				clk_base = clockCycle
			addressAccessed.append(address)
			cyclesAccessed.append(clockCycle - clk_base)

	text_file = open("Output.txt", "w")
	last_row = -1

	for i in range(len(addressAccessed)):
		temp = []
		bankAccessed, rankAccessed, rowAccessed = getDramPhyLoc(addressAccessed[i])
		
		if bankAccessed != 0 or rankAccessed != 0: # filtering out only one bank
			continue
		if rowAccessed == last_row: # if same row is accessed, it will be served from row buffer. hence, not important
			continue
		last_row = rowAccessed
		text_file.write("%d \t %d \t %d \t %d \t %d\n" % (addressAccessed[i], bankAccessed, rankAccessed, rowAccessed, cyclesAccessed[i]))
	text_file.close()
